C coefficients devant p_1.p_2/(p_1.p_5 p_2.p_5)
C ----------------------------------------------------
	SUBROUTINE VEC_H12D(S12,S13,S14,S15,S23,S24,S25,S34,S35,S45,
     #	VH12)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	COMMON/GDF/JNF
	PARAMETER (J0MAX=1,I0MAX=2)
	DIMENSION VH12(J0MAX),VTEMP(I0MAX)
	DIMENSION QCH(6)
	DATA QCH/-0.333333333333D0,0.666666666667D0,
     #	-0.333333333333D0,0.666666666667D0,
     #	-0.333333333333D0,0.666666666667D0/
	DO I = 1,J0MAX
	  VH12(I) = 0.D0
	ENDDO
	DO I = 1,I0MAX
	  VTEMP(I) = 0.D0
	ENDDO
	VC = (N**2-1.D0)
C
C	j0 = 1 : ph + ph --> parton + ph
C
	DO I=1,JNF
	  EQI = QCH(I)
c       ph + ph --> qi + ph
      hh12 = -8.D0/s12*N*eqi**6/s34/s13/s23*(s25**3*s23+s25*s23**3+s45**
     #3*s34+s45*s34**3+s15**3*s13+s15*s13**3)
	VTEMP(1) = HH12 + VTEMP(1)
c       ph + ph --> qbi + ph
      hh12 = -8.D0/s12*N*eqi**6/s34/s23/s13*(s15**3*s13+s15*s13**3+s45**
     #3*s34+s45*s34**3+s25**3*s23+s25*s23**3)
	VTEMP(2) = HH12 + VTEMP(2)
	ENDDO
	VH12(1) = VTEMP(1) + VTEMP(2)
	RETURN
	END
