c functions needed for subroutine gfill below
	real function wacos(x)
	implicit real*4 (a-h,l-z)
	un = 1.
	unp = 1. + 1.e-4
	zero = 0.
	pi=atan(1.)*4.
	if (abs(x).le.un) then
	  wacos = acos(x)
	else if (abs(x).gt.un.and.abs(x).lt.unp) then
	  if (x.lt.zero) then
	    wacos = pi
	  else
	    wacos = 0.
	  endif
	else
	  write (*,*) 'alerte dans wacos argument > 1:',x
	  wacos = 0.
	endif
	return
	end
C ******************************************************************
c attention, jet options are less than in ephox 
c (JPh's last changes not included in gaga)
C same as jet_algorithm but without double precision numbers
	subroutine jet_algo_histo(r35,pt3,pt5,algorithm,r_kt,r_c,
     #	r_sep,merged)
	implicit real*4 (a-h,l-z)
	logical merged
	character*2 algorithm
c algorithme en kt
c d35 = min(pt5**2,pt3**2)*r35s
c d3 = pt3**2*r_kt**2
c d5 = pt5**2*r_kt**2
c comme pt5<=pt3 la condition d35 <= d3,d5 devient
c r35s <= r_kt**2
	if (algorithm(1:2).eq.'kt') then
	  if (r35.le.r_kt) then
	    merged = .true.
	  else
	    merged = .false.
	  endif
c algorithme en cone
c comme pt5<=pt3, on trace un cone autour de 3, la condition 5 
c appartient a ce cone est:
c r35s <= r_c**2
	else if (algorithm(1:2).eq.'co') then
	  if (r35.le.r_c) then
	    merged = .true.
	  else
	    merged = .false.
	  endif
c algorithme en cone (avec des semences qui ne sont pas dans la direction 
c des partons) on balade un cone dans le plan y-phi, si les deux partons 
c tombent dedans (et si leur distance est plus petite que r_sep alors 
c on associe)
c comme pt5<=pt3, la condition pour que les deux partons soient dans le 
c cone est: r35 <= p_tjet/pt5*r_c
	else if (algorithm(1:2).eq.'se') then
	  ptjet = pt3+pt5
	  if (pt5.ne.0.d0) then
	    ptjet_s_pt5 = ptjet/pt5
	  else
	    ptjet_s_pt5 = 1.d+8
	  endif
** 	  write (*,*)  r35,pt3,pt5,algorithm,r_kt,r_c,
**      #	r_sep 
	  if (r35.le.ptjet_s_pt5*r_c.and.r35.le.r_sep) then
	    merged = .true.
	  else
	    merged = .false.
	  endif
	endif
	return
	end	
c ******************************************************************	
C fills histograms for photon pt, jet pt, phi , pair pt
c implements  cuts 
c here photon is particle 3!!!!!!!!!!!!!!!!!!!!
c 
	subroutine gfill
	implicit real*4 (a-h,l-y)
	integer maxtrk,ntrack,isofrixione
        parameter (maxtrk = 3)
	logical rapidite,pete,isol,masscut,sumcut
	logical rapjet,petejet,isoljet,merged
	logical igampass,xgamcut
	LOGICAL DDD,DDF,DRD,RDD,DRF,RRD,RRF,dir,frag
        common/sortier/ntrack,we(maxtrk),wpx(maxtrk),
     #	wpy(maxtrk),wpz(maxtrk)
	common/fixle/iprov,weight
	common/pclass/DDD,DDF,DRD,RDD,DRF,RRD,RRF
	common/sfragvr/wx1,wx2,wxobs,weta1,weta2
	common/isophot/iphotisol
c	common/frixione/isofrixione
	common/jets/jetmode
	character*2 algorithm
	common/algorithme/algorithm
	common/testc/jcount

	xinfty = 1.e+8
	del = 1.e-4
	pi = atan(1.)*4.
	isofrixione = 1
c sqrt of S (GeV) and LAB electron energy (needed for def of xgamma)	
c	rs = 196.6
c defined in cuts_etc according to parameter.input
c    
c	
c ************************ cut parameter input **********************
	call cuts_etc(rs,
     #  pt_photmin,pt_photmax,y_photmin,y_photmax,pt_jet1min,
     #  pt_jet1max,y_jet1min,y_jet1max,algorithm,r_kt,r_c,
     #  r_sep,xgam_min,iflag_xgam)
c 
c
	dir = DDD.OR.DRD.OR.RDD.OR.RRD
	frag= DDF.OR.DRF.OR.RRF
c for debugging (to trace back origin):	
	if (ddd) then 
	  ifl = 1
	else if (drd) then
	  ifl = 2
	else if (rdd)  then 
	  ifl = 3 
	else if (rrd) then 
	  ifl = 4
	endif       
c
	if (dir) then
	  wx1 = 1.
	  wx2 = 1.
	endif 
	pt3 = sqrt(wpx(1)**2+wpy(1)**2)
	pt4 = sqrt(wpx(2)**2+wpy(2)**2)
c	
	y3 = log((we(1)+wpz(1))/(we(1)-wpz(1)))*0.5
	y4 = log((we(2)+wpz(2))/(we(2)-wpz(2)))*0.5
c
	if (ntrack.eq.3) then
	  pt5 = sqrt(wpx(3)**2+wpy(3)**2)
	  xnumy5 = (we(3)+wpz(3))
	  xdeny5 = (we(3)-wpz(3))
	  if (xnumy5.eq.0..or.xdeny5.eq.0.) then
	    if (wpz(3).le.0.) then
	      y5 = -xinfty
	    else
	      y5 = xinfty
	    endif
	  else if (xnumy5.gt.0..and.xdeny5.gt.0.) then
	    y5 = log((we(3)+wpz(3))/(we(3)-wpz(3)))*0.5
	  endif
	else if (iprov.eq.23) then
	  y5 = y3
	  if (dir) then
	    pt5 = pt4-pt3
	  else if (frag) then
	    pt5 = pt4-pt3/wx1
	  endif
	else
	  pt5 =0.
	  y5=0.
	endif
	cfi34 = (wpx(1)*wpx(2)+wpy(1)*wpy(2))/(pt3*pt4)
	if (ntrack.eq.3) then
	  cfi35 = (wpx(1)*wpx(3)+wpy(1)*wpy(3))/(pt3*pt5)
	  cfi45 = (wpx(3)*wpx(2)+wpy(3)*wpy(2))/(pt5*pt4)
	  fi35 = wacos(cfi35)
	  fi45 = wacos(cfi45)
	  fi34 = wacos(cfi34)
	endif
c	
c def of qt of the pair photon-parton4	
	qt = sqrt( (wpx(1)+wpx(2))**2+(wpy(1)+wpy(2))**2 )
c
c jet definition  
c 
	if (ntrack.eq.3) then
	  dist45 = sqrt((y4-y5)**2+(fi45)**2)
	  call jet_algo_histo(dist45,pt4,pt5,algorithm,
     #	  r_kt,r_c,r_sep,merged)
	  if (.not.merged) then
	    pt_jet1 = pt4
	    y_jet1 = y4
	    if (wpy(2).le.0.) then 
	      phi_jet1 = 2*pi-wacos(wpx(2)/pt4)
	    else 
	      phi_jet1 = wacos(wpx(2)/pt4)
	    endif
	    e_j1 =    we(2)
	    pt_j1x = wpx(2)
	    pt_j1y = wpy(2)
	    p_j1z =  wpz(2)
	    pt_jet2 = pt5
	    y_jet2 = y5
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	  else if (merged) then
	    pt_jet1 = pt4 + pt5
	    y_jet1 = (y4*pt4 + y5*pt5)/pt_jet1
c	    
c      (absolute fi not needed, take everytihing relative to photon axis)	    
c	    if (wpy(2).le.0.) then 
c	      fi4 = 2*pi-wacos(wpx(2)/pt4)
c	    else 
c	      fi4 = wacos(wpx(2)/pt4)
c	    endif
c	    if (wpy(3).le.0.) then 
c	      fi5 = 2*pi-wacos(wpx(3)/pt5)
c	    else 
c	      fi5 = wacos(wpx(3)/pt5)
c	    endif
 	    if  (wpy(1).lt.0.) then 
	      figam = 2*pi-wacos(wpx(1)/pt3)
	    else 
	      figam = wacos(wpx(1)/pt3)
	    endif
c fix fi34 to be < pi => fi35 originally has been > pi	
	    fi35ori = 2*pi-wacos(cfi35)
	    delphi = (fi34*pt4+fi35ori*pt5)/pt_jet1
	    tpi=2*pi
	    if (delphi.gt.pi.and.delphi.lt.tpi) then
	        delphi = 2*pi-delphi
	    endif  
	    phi_jet1 = (fi34*pt4+fi35ori*pt5)/pt_jet1 + figam   
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc                                
            e_j1 =    we(2) +  we(3)
     	    pt_j1x = wpx(2) + wpx(3) 
	    pt_j1y = wpy(2) + wpy(3)
	    p_j1z =  wpz(2) + wpz(3)
	  endif
	else
	  pt_jet1 = pt4
	  y_jet1 = y4
	  if (wpy(2).le.0.) then 
	     phi_jet1 = 2*pi-wacos(wpx(2)/pt4)
	  else 
	     phi_jet1 = wacos(wpx(2)/pt4)
	  endif
	  e_j1 =    we(2)
	  pt_j1x = wpx(2)
	  pt_j1y = wpy(2)
	  p_j1z =  wpz(2)
	endif
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
	  cfigj = (wpx(1)*pt_j1x + wpy(1)*pt_j1y)/(pt3*pt_jet1)
 	  fisno = wacos( cfigj )
c          fisno = delphi
c
c def of x_gamma^obs also in BASES subroutines
c
	xgamobs1=(pt3*exp(y3)+pt_jet1*exp(y_jet1))/(rs*weta1)
	xgamobs2=(pt3*exp(-y3)+pt_jet1*exp(-y_jet1))/(rs*weta2)
	xgameas1=(we(1)+wpz(1)+e_j1+p_j1z)/(rs*weta1)
	xgameas2=(we(1)-wpz(1)+e_j1-p_j1z)/(rs*weta2)
	xgamll1 =pt3*(exp(y3)+exp(y_jet1))/(rs*weta1)
	xgamll2 =pt3*(exp(-y3)+exp(-y_jet1))/(rs*weta2)
	xgamobases1 = wxobs
c	
	wt=rs*sqrt(weta1*weta2)
        xgamt=2*pt3/wt
c
	sum_gaj=pt3+pt_jet1	
	mingj=min(pt3,pt_jet1)
	maxgj=max(pt3,pt_jet1)
	sumcut=(sum_gaj.gt.12.)
c		
c			
c define isolation cuts, cut in photon rapidity, pt
c
c isolation is defined on integration level, so do not redo it here!!!!
c
	isol = .true.
c  
c	photon:	
	rapidite = (y3.le.y_photmax.and.y3.ge.y_photmin)
	pete = pt3.ge.pt_photmin
	igampass = (rapidite.and.pete)
c	jet:	
	rapjet = (y_jet1.le.y_jet1max.and.y_jet1.ge.y_jet1min)
	petejet = (pt_jet1.ge.pt_jet1min.and.pt_jet1.le.pt_jet1max)
	isoljet = (rapjet.and.petejet)
c count effect of isolation in histo only	   
c	IF (.not.isol) THEN
c	jcount=jcount+1
c	ENDIF	
c	cut on x_gamma1~x_gam^-:
	IF (iflag_xgam.eq.0) THEN	
	  xgamcut = (xgameas2.ge.xgam_min)
	ELSE IF(iflag_xgam.eq.1) THEN
	  xgamcut = (xgamobs2.ge.xgam_min)	
	ELSE IF(iflag_xgam.eq.2) THEN	
	  xgamcut = (xgamll2.ge.xgam_min)
	ELSE
	  xgamcut = .true.
	write(18,*) 'warning, flag_xgam not properly defined'
	ENDIF 	
c	
c 	in inclusive mode isoljet is always true
	IF (jetmode.eq.0) THEN
	   isoljet = .TRUE.
	ENDIF  
	if (igampass.and.isol.and.isoljet.and.xgamcut) then
c	
c fill histograms (adjust def of histos with working/param_histo.indat
c and start.pl)
c
	  call fill_histo(iprov,weight,
     #             pt_jet1,y_jet1,pt3,y3,xgamobs1,xgamobs2,
     #             xgamll1,xgameas1,xgamll2,xgameas2,wt,xgamt)
	endif
	end
