C*****************************************************
C Definition of various small functions
C*****************************************************	
C
c	SUBROUTINE XTHET(ZMAX,BSUP)
c	IMPLICIT REAL*8 (A-H,L-Z)
c	UN = 1.D0
c	IF (ZMAX.EQ.UN) THEN
c	  BSUP = UN
c	ELSE IF (ZMAX.LT.UN) THEN
c	  BSUP = 0.D0
c	ENDIF
c	RETURN
c	END 
C********************************************************
	REAL*8 FUNCTION SCA(P,Q)
	IMPLICIT REAL*8 (A-H,L-Z)
	DIMENSION P(4),Q(4)
	SCA=P(1)*Q(1)-P(2)*Q(2)-P(3)*Q(3)-P(4)*Q(4)
	RETURN
	END
C*********************************************************
c	DOUBLE PRECISION FUNCTION ZACOS(X)
c	IMPLICIT REAL*8 (A-H,L-Z)
c	UN = 1.D0
c	UNP = 1.D0 + 1.D-8
c	ZERO = 0.D0
c	PI=DATAN(1.D0)*4.D0
c	IF (DABS(X).LE.UN) THEN
c	  ZACOS = DACOS(X)
c	ELSE IF (DABS(X).GT.UN.AND.DABS(X).LT.UNP) THEN
c	  IF (X.LT.ZERO) THEN
c	    ZACOS = PI
c	  ELSE
c	    ZACOS = 0.D0
c	  ENDIF
c	ELSE
c	  WRITE (*,*) 'ALERTE DANS ZACOS ARGUMENT > 1:',X
c	  ZACOS = 0.D0
c	ENDIF
c	RETURN
c	END
C********************************************************************
c	double precision function coshmcos(y,fi)
c	implicit real*8 (a-h,l-z)
c	petit = 1.d-3
c	yy = dabs(y)
c	if (yy.le.petit.and.fi.gt.petit) then
c	  coshmcos = 1+y**2/2.d0+y**4/24.d0+y**6/720.d0-dcos(fi)
c	else if (yy.gt.petit.and.fi.le.petit) then
c	  coshmcos = dcosh(y)-(1-fi**2/2.d0+fi**4/24.d0-fi**6/720.d0)
c	else if (yy.le.petit.and.fi.le.petit) then
c	  coshmcos = (y**2+fi**2)/2.d0+(y**4-fi**4)/24.d0+
c     #	  (y**6+fi**6)/720.d0
c	else if (yy.gt.petit.and.fi.gt.petit) then
c	  coshmcos = dcosh(y)-dcos(fi)
c	endif
c	end
C********************************************************************
