c cette routine renvoie vrai ou faux suivant que le(s) jet(s) sont dans
c les coupures cinematiques de l'experience:
c ces coupures se font toujours sur le pt et la rapidite du(des) jet(s)
c l'angle azymuthal n'est donc pas calcule ici
c difference to jet_definition_ori.f: 
c subroutine also fills the common with pt and rapidity of the jet
c in order to be able to define x_gam^obs before event generation
c
	subroutine jet_selection(y3,y5,fi35,pt3,pt5,algorithm,
     #	r_kt,r_c,r_sep,ptjet_min,ptjet_max,yjet_min,yjet_max,cut_jet)
	implicit real*8 (a-h,l-z)
	logical merged,cut_pt,cut_y,cut_jet
	character*2 algorithm
	dimension ptjet(2),yjet(2),fijet(2)
	common/jetkin/ptjet1,yjet1
	common/jetnb/inb_jet 
c	
	r35s = (y3-y5)**2 + fi35**2
	r35 = dsqrt(r35s)
	call jet_algorithm(r35,pt3,pt5,algorithm,r_kt,r_c,r_sep,merged)
c regle d'association: snowmass
	if (merged) then
	  inb_jet = 1
	  ptjet(1) = pt3 + pt5
	  yjet(1) = pt3/ptjet(1)*y3 + pt5/ptjet(1)*y5
	else	
	  inb_jet = 2
	  ptjet(1) = pt3
	  yjet(1) = y3
	  ptjet(2) = pt5
	  yjet(2) = y5
	endif
	  ptjet1 = ptjet(1)
	  yjet1 = yjet(1)
c	  
	cut_pt = (ptjet(1).le.ptjet_max).and.(ptjet(1).ge.ptjet_min)
	cut_y = (yjet(1).le.yjet_max).and.(yjet(1).ge.yjet_min)
	if (cut_pt.and.cut_y) then
	  cut_jet = .true.
	else
	  cut_jet = .false.
	endif
	end
c
	subroutine jet_algorithm(r35,pt3,pt5,algorithm,r_kt,r_c,
     #	r_sep,merged)
	implicit real*8 (a-h,l-z)
	logical merged
	character*2 algorithm
c algorithme en kt
c d35 = min(pt5**2,pt3**2)*r35s
c d3 = pt3**2*r_kt**2
c d5 = pt5**2*r_kt**2
c comme pt5<=pt3 la condition d35 <= d3,d5 devient
c r35s <= r_kt**2
	if (algorithm(1:2).eq.'kt') then
	  if (r35.le.r_kt) then
	    merged = .true.
	  else
	    merged = .false.
	  endif
c algorithme en cone
c comme pt5<=pt3, on trace un cone autour de 3, la condition 5 
c appartient a ce cone est:
c r35s <= r_c**2
	else if (algorithm(1:2).eq.'co') then
	  if (r35.le.r_c) then
	    merged = .true.
	  else
	    merged = .false.
	  endif
c algorithme en cone (avec des semences qui ne sont pas dans la direction 
c des partons) on balade un cone dans le plan y-phi, si les deux partons 
c tombent dedans (et si leur distance est plus petite que r_sep alors 
c on associe)
c comme pt5<=pt3, la condition pour que les deux partons soient dans le 
c cone est: r35 <= p_tjet/pt5*r_c
	else if (algorithm(1:2).eq.'se') then
	  ptjet = pt3+pt5
	  if (pt5.ne.0.d0) then
	    ptjet_s_pt5 = ptjet/pt5
	  else
	    ptjet_s_pt5 = 1.d+8
	  endif
** 	  write (*,*)  r35,pt3,pt5,algorithm,r_kt,r_c,
**      #	r_sep 
	  if (r35.le.ptjet_s_pt5*r_c.and.r35.le.r_sep) then
	    merged = .true.
	  else
	    merged = .false.
	  endif
	endif
	return
	end
