C coefficients devant p_1.p_2/(p_1.p_5 p_2.p_5)
C ----------------------------------------------------
	SUBROUTINE VEC_H12rdd(S12,S13,S14,S15,S23,S24,S25,
     #	S34,S35,S45,VH12)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUL/N,CF,GTR
	COMMON/GDF/JNF
	PARAMETER (J0MAX=2,I0MAX=4)
	DIMENSION VH12(J0MAX),VTEMP(I0MAX)
	DIMENSION QCH(6)
	DATA QCH/-0.333333333333D0,0.666666666667D0,
     #	-0.333333333333D0,0.666666666667D0,
     #	-0.333333333333D0,0.666666666667D0/
	DO I = 1,J0MAX
	  VH12(I) = 0.D0
	ENDDO
	DO I = 1,I0MAX
	  VTEMP(I) = 0.D0
	ENDDO
	VC = (N**2-1.D0)
C
C	j0 = 1 : qi + ph --> jet + ph
C
	EQI = 0.333333333333D0
C	(include numerators of charges later in struct_rdd.f)
c        qi + ph --> qi + ph
      hh12 = 0.D0
	VTEMP(1) = HH12
c        qi + ph --> g + ph
      hh12 = 0.D0
	VTEMP(2) = HH12
	VH12(1) = VTEMP(1) + VTEMP(2)
C
C	j0 = 2 : g + ph --> jet + ph
C
	DO I=1,JNF
	  EQI = QCH(I)
c        g + ph --> qi + ph
      hh12 = -8.D0/s12*N*eqi**4*CF/s34/s13/s23*(s25**3*s23+s25*s23**3+s4
     #5**3*s34+s45*s34**3+s15**3*s13+s15*s13**3)
	VTEMP(3) = HH12 + VTEMP(3)
c        g + ph --> qbi + ph
      hh12 = -8.D0/s12*N*eqi**4*CF/s34/s13/s23*(s23**3*s25+s23*s25**3+s3
     #4**3*s45+s34*s45**3+s13**3*s15+s13*s15**3)
	VTEMP(4) = HH12 + VTEMP(4)
	ENDDO
	VH12(2) = VTEMP(3) + VTEMP(4)
	RETURN
	END
