	subroutine histo_init(inbevent)
	implicit real*8 (a-h,l-v,x-z)
	implicit real*4 (w)
	CHARACTER*128 PATH_RZFILE
	COMMON/CHEMINRZ/PATH_RZFILE
	COMMON/LONGRZ/ILENRZ
	parameter(iwpawc = 11550000)
	common/pawc/hmemor(iwpawc)
	parameter (nbhisto=6)
	common/init_close/ibin(6),wxmin(2),wxmax(2)
	common/nonequi/wxbinx_gam_LL2lo(6),
     #   wxbinx_gam_LL2nlo(6),
     #   wxbinpt_gamlo(6),
     #   wxbinpt_gamnlo(6)
c
	iwpawt = 150000*7*inbevent/1000000
	if(iwpawt.gt.iwpawc) then
	  write(6,*)' you must have iwpawc at least ',iwpawt
	stop
	endif
	call hlimit(iwpawc)
	call hropen(1,'opal',PATH_RZFILE(1:ILENRZ)//'.dat'
     #	,'n',1024,istat)
c 
	ibin(1) = 5
	wxmin(1) = 0.
	wxmax(1) = 1.
c
	ibin(2) = 5
	wxmin(2) = 0.
	wxmax(2) = 1.
c
c     bins for histo in  x_gam_LL2lo
	ibin(3) = 5
	wxbinx_gam_LL2lo(1) = 0.
	wxbinx_gam_LL2lo(2) = 0.3125
	wxbinx_gam_LL2lo(3) = 0.625
	wxbinx_gam_LL2lo(4) = 0.875
	wxbinx_gam_LL2lo(5) = 1.125
	wxbinx_gam_LL2lo(6) = 1.375
c
c     bins for histo in  x_gam_LL2nlo
	ibin(4) = 5
	wxbinx_gam_LL2nlo(1) = 0.
	wxbinx_gam_LL2nlo(2) = 0.3125
	wxbinx_gam_LL2nlo(3) = 0.625
	wxbinx_gam_LL2nlo(4) = 0.875
	wxbinx_gam_LL2nlo(5) = 1.125
	wxbinx_gam_LL2nlo(6) = 1.375
c
c     bins for histo in  pt_gamlo
	ibin(5) = 5
	wxbinpt_gamlo(1) = 3.
	wxbinpt_gamlo(2) = 4.
	wxbinpt_gamlo(3) = 5.
	wxbinpt_gamlo(4) = 6.
	wxbinpt_gamlo(5) = 8.
	wxbinpt_gamlo(6) = 13.
c
c     bins for histo in  pt_gamnlo
	ibin(6) = 5
	wxbinpt_gamnlo(1) = 3.
	wxbinpt_gamnlo(2) = 4.
	wxbinpt_gamnlo(3) = 5.
	wxbinpt_gamnlo(4) = 6.
	wxbinpt_gamnlo(5) = 8.
	wxbinpt_gamnlo(6) = 13.
c
	call hbook1(20,'dsigma/detagalo',ibin(1),wxmin(1),wxmax(1),0.)
	call hbook1(920,'dummy',ibin(1),wxmin(1),wxmax(1),0.)
	call hbarx(20)
	call hbarx(920)
c
	call hbook1(21,'dsigma/detaga',ibin(2),wxmin(2),wxmax(2),0.)
	call hbook1(921,'dummy',ibin(2),wxmin(2),wxmax(2),0.)
	call hbarx(21)
	call hbarx(921)
c
	call hbookb(22,'dsigma/dxgamll2lo',ibin(3),wxbinx_gam_LL2lo,0.)
	call hbookb(922,'dummy',ibin(3),wxbinx_gam_LL2lo,0.)
	call hbarx(22)
	call hbarx(922)
c
	call hbookb(23,'dsigma/dxgamll2',ibin(4),wxbinx_gam_LL2nlo,0.)
	call hbookb(923,'dummy',ibin(4),wxbinx_gam_LL2nlo,0.)
	call hbarx(23)
	call hbarx(923)
c
	call hbookb(24,'dsigma/dptgalo',ibin(5),wxbinpt_gamlo,0.)
	call hbookb(924,'dummy',ibin(5),wxbinpt_gamlo,0.)
	call hbarx(24)
	call hbarx(924)
c
	call hbookb(25,'dsigma/dptga',ibin(6),wxbinpt_gamnlo,0.)
	call hbookb(925,'dummy',ibin(6),wxbinpt_gamnlo,0.)
	call hbarx(25)
	call hbarx(925)
c
	return
	end
